#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Aqua
#property indicator_color2 Salmon
#property indicator_color3 Yellow

//---- input parameters
extern int MAFast = 10;
extern int MASlow = 30;
//extern int MAType = MODE_SMA;
extern int MAPrice = PRICE_CLOSE;
//---- buffers
double SMA[];
double EMA[];
double LWMA[];

string prices[] = { "Close", "Open", "High", "Low", "Median", "Typical", "Weighted" };

int init()
{
    string short_name;

    MAPrice = MathMax( MAPrice, 0 );
    MAPrice = MathMin( MAPrice, ArraySize( prices ) - 1 );

    if ( MAFast > MASlow ) {
        int a = MAFast;
        MAFast = MASlow;
        MASlow = a;
    }

    IndicatorShortName( "Mom:" + prices[MAPrice] + "(" + MAFast + "," + MASlow + ")" );

    SetIndexStyle( 0, DRAW_LINE );
    SetIndexBuffer( 0, SMA );
    SetIndexLabel( 0, "SMA" );
    SetIndexDrawBegin( 0, MASlow );

    SetIndexStyle( 1, DRAW_LINE );
    SetIndexBuffer( 1, EMA );
    SetIndexLabel( 1, "EMA" );
    SetIndexDrawBegin( 1, MASlow );

    SetIndexStyle( 2, DRAW_LINE );
    SetIndexBuffer( 2, LWMA );
    SetIndexLabel( 2, "LWMA" );
    SetIndexDrawBegin( 2, MASlow );

    return( 0 );
}

int start()
{
    for ( int bar = Bars - IndicatorCounted(); bar >= 0; bar-- ) {
        indicate( bar );
    }
    return(0);
}

void indicate(int bar)
{
    SMA[ bar ] = 0;
    EMA[ bar ] = 0;
    LWMA[ bar ] = 0;
    
    if( Bars <= MASlow )
        return(0);

    SMA[ bar ] = expr( bar, MODE_SMA );
    EMA[ bar ] = expr( bar, MODE_EMA );
    LWMA[ bar ] = expr( bar, MODE_LWMA );
}

double expr(int bar,int MAType)
{
    double fast = iMA( Symbol(), Period(), MAFast, 0, MAType, MAPrice, bar );
    double slow = iMA( Symbol(), Period(), MASlow, 0, MAType, MAPrice, bar );
    if ( slow == 0 )
        return( 0 );
    return ( ( fast - slow ) / slow );
}
//+------------------------------------------------------------------+